<template>
  <div class="product-show">
    <v-content>
      <v-container fluid>
        <router-link style="text-decoration: none;" to="/products">
          <v-btn class="ma-2" text>
            <v-icon dark left>mdi-arrow-left</v-icon>Retour à la liste
          </v-btn>
        </router-link>

        <div class="d-flex align-start">
          <v-col
            cols="12"
            xs="12"
            sm="12"
            md="6"
            lg="6"
            xl="6"
            class="d-flex align-start justify-end"
          >
            <div class="d-flex align-start flex-column">
              <v-img
                :src="initialImg"
                aspect-ratio="2"
                width="70"
                height="90"
                style="margin: 0px 15px 15px 15px;"
                contain
                @mouseover="changeImage(initialImg)"
              ></v-img>

              <v-img
                :src="myImage"
                aspect-ratio="2"
                width="70"
                height="90"
                style="margin: 15px;"
                contain
                @mouseover="changeImage(myImage)"
              ></v-img>

              <v-img
                :src="myImage2"
                aspect-ratio="2"
                width="70"
                height="90"
                style="margin: 15px;"
                contain
                @mouseover="changeImage(myImage2)"
              ></v-img>

              <v-img
                :src="otherImage"
                aspect-ratio="2"
                width="70"
                height="90"
                style="margin: 15px;"
                contain
                @mouseover="changeImage(otherImage)"
              ></v-img>
            </div>

            <div class="d-flex flex-column">
              <v-img :src="coverImg" aspect-ratio="2" width="600" height="800" contain></v-img>

              <p>{{product.numProduct}}</p>
            </div>
          </v-col>

          <v-col
            cols="12"
            xs="12"
            sm="12"
            md="6"
            lg="6"
            xl="6"
            class="d-flex align-start justify-start"
          >
            <div class="d-flex align-start flex-column" style="width: 100%;">
              <v-col cols="12" xs="12" sm="12" md="8" lg="8" xl="8">
                <div class="headline font-weight-bold mb-3">
                  <h2>{{product['name']}}</h2>
                </div>

                <div class="d-flex flex-column mb-5">
                  <div v-if="nbComments" class="body-2">
                    <span>
                      Noté
                      <star-rating
                        :inline="true"
                        :star-size="20"
                        :read-only="true"
                        :show-rating="false"
                        :rating="rateProduct"
                        :round-start-rating="false"
                      ></star-rating>
                      par les utilisateurs sur un total de {{nbComments}}
                    </span>
                  </div>
                  <div v-else class="body-2">
                    <span>Aucune note sur ce produit. Soyez le premier à commenter !</span>
                  </div>
                  <a href="#ajouter-un-com" class="caption">Ajouter un commentaire</a>
                </div>

                <div class="headline font-weight-bold mb-3">
                  <h3>{{product['price']}} €</h3>
                </div>

                <div class="mb-3">
                  <span v-if="stock > 0" style="color:green;">Disponible</span>
                  <span v-else style="color:red;">Non disponible</span>
                </div>
              </v-col>

              <v-col
                cols="12"
                xs="12"
                sm="12"
                md="8"
                lg="8"
                xl="8"
                class="d-flex align-start justify-start"
              >
                <div class="mb-3">
                  <span>{{product['description']}}</span>
                </div>
              </v-col>

              <v-col cols="12" xs="12" sm="12" md="8" lg="8" xl="8">
                <div class="d-flex flex-column">
                  <div class="d-flex">
                    <v-col cols="12" xs="12" sm="12" md="3" lg="3" xl="3">
                      <v-text-field
                        dense
                        :disabled="disabled()"
                        v-model="jourLocation"
                        label="Jours (en jour)"
                      ></v-text-field>
                    </v-col>
                  </div>
                </div>

                <div class="mb-3">
                  <router-link style="text-decoration: none;" class="mr-3" to="#">
                    <v-btn
                      :disabled="disabled()"
                      color="orange"
                      class="mb-2 mb-sm-0"
                      style="color: white;"
                    >
                      <v-icon style="text-decoration: none;">mdi-cart-plus</v-icon>Ajouter au panier
                    </v-btn>
                  </router-link>
                </div>

                <div class="d-flex align-center mt-3">
                  <v-btn icon color="primary">
                    <a
                      :href="`https://www.facebook.com/sharer/sharer.php?u=${currentLocation}`"
                      target="_blank"
                      style="text-decoration: none;"
                    >
                      <v-icon>mdi-facebook</v-icon>
                    </a>
                  </v-btn>

                  <v-btn icon color="blue lighten-2">
                    <a
                      :href="`https://twitter.com/intent/tweet?url=${currentLocation}`"
                      target="_blank"
                      style="text-decoration: none;"
                    >
                      <v-icon>mdi-twitter</v-icon>
                    </a>
                  </v-btn>
                </div>
              </v-col>
            </div>
          </v-col>
        </div>

        <v-row>
          <v-col
            cols="12"
            xs="12"
            sm="12"
            md="5"
            lg="5"
            xl="5"
            offset-md="1"
            offset-lg="1"
            offset-xl="1"
          >
            <h2>Commentaires</h2>
          </v-col>
        </v-row>

        <v-row>
          <v-col
            cols="12"
            xs="12"
            sm="12"
            md="5"
            lg="5"
            xl="5"
            offset-md="1"
            offset-lg="1"
            offset-xl="1"
            class="d-flex align-start justify-start"
          >
            <CommentList v-bind:comments="product.comments" />
          </v-col>

          <v-col
            cols="12"
            xs="12"
            sm="12"
            md="6"
            lg="6"
            xl="6"
            class="d-flex align-start justify-start"
            id="ajouter-un-com"
          >
            <CommentCreate v-bind:user="userData" v-bind:product="product" />
          </v-col>
        </v-row>
      </v-container>
    </v-content>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import { mapFields } from "vuex-map-fields";
import CommentList from "../../comment/List";
import CommentCreate from "../../comment/Create";
import StarRating from "vue-star-rating";

const servicePrefix = "Product";

export default {
  name: "ProductShow",
  servicePrefix,
  components: {
    CommentList,
    CommentCreate,
    StarRating
  },
  data() {
    return {
      currentLocation: window.location.href,
      quantite: "",
      jourLocation: "",
      coverImg: "http://imgur.com/hNSHGtB.jpg",
      initialImg: "http://imgur.com/hNSHGtB.jpg",
      myImage:
        "https://s-media-cache-ak0.pinimg.com/originals/bd/5d/84/bd5d845c980508d41b0329dc21d08d2b.jpg",
      myImage2: "http://imgur.com/O8KeEjx.jpg",
      otherImage:
        "https://cdn.pixabay.com/photo/2014/03/29/09/17/cat-300572_960_720.jpg",
      userData: JSON.parse(localStorage.getItem("user"))
    };
  },
  computed: {
    ...mapFields("product", {
      product: "product"
    }),
    stock: function() {
      let cpt = 0;
      this.product.stocks.map(test => {
        cpt = cpt + test.quantity;
      });
      return cpt;
    },
    rateProduct: function() {
      let cpt = 0;
      let nbComments = 0;
      this.product.comments.map(test => {
        cpt = cpt + test.notation;
        nbComments = nbComments + 1;
      });
      if (nbComments == 0) {
        return false;
      }
      return parseInt((cpt / nbComments).toPrecision(3));
    },
    nbComments: function() {
      let nbComments = 0;
      let com = " commentaires.";
      this.product.comments.map(() => {
        nbComments = nbComments + 1;
      });
      if (nbComments == 1) {
        com = " commentaire.";
      } else if (nbComments == 0) {
        return false;
      }
      return nbComments + com;
    }
  },
  methods: {
    ...mapActions("product", ["getProduct"]),
    changeImage: function(newImage) {
      this.coverImg = newImage;
    },
    disabled: function() {
      if (this.stock > 0) {
        return false;
      }
      return true;
    }
  },
  mounted: function() {
    this.$nextTick(function() {
      this.getProduct(location.pathname.split("/")[2]);
    });
  }
};
</script>

<style scoped>
.v-image {
  cursor: pointer;
}
</style>
